summaryrefslogtreecommitdiff
path: root/plugins
diff options
context:
space:
mode:
authorBrice Dutheil <brice.dutheil@gmail.com>2014-01-04 22:06:09 +0100
committerBrice Dutheil <brice.dutheil@gmail.com>2014-01-04 22:08:00 +0100
commit9ce1b6289aebc8e19b8bb25e4f7ac1cbc84e83de (patch)
tree931fbf3d8fcb008ca34dca0cd2d6fd0e231e441a /plugins
parente2838f75f0be001cf34da321c9c712d48699e518 (diff)
downloadzsh-9ce1b6289aebc8e19b8bb25e4f7ac1cbc84e83de.tar.gz
zsh-9ce1b6289aebc8e19b8bb25e4f7ac1cbc84e83de.tar.bz2
zsh-9ce1b6289aebc8e19b8bb25e4f7ac1cbc84e83de.zip
new faster SVN plugin
Diffstat (limited to 'plugins')
-rw-r--r--plugins/svn-fast-info/svn-fast-info.plugin.zsh64
1 files changed, 64 insertions, 0 deletions
diff --git a/plugins/svn-fast-info/svn-fast-info.plugin.zsh b/plugins/svn-fast-info/svn-fast-info.plugin.zsh
new file mode 100644
index 000000000..d8fc53989
--- /dev/null
+++ b/plugins/svn-fast-info/svn-fast-info.plugin.zsh
@@ -0,0 +1,64 @@
+# vim:ft=zsh ts=2 sw=2 sts=2
+#
+# Faster alternative to the current SVN plugin implementation.
+#
+# Works with svn 1.6, 1.7, 1.8.
+# Use `svn_prompt_info` method to enquire the svn data.
+# It's faster because his efficient use of svn (single svn call) done in the `parse_svn` function
+# Also changed prompt suffix *after* the svn dirty marker
+#
+# *** IMPORTANT *** DO NO USE with the simple svn plugin, this plugin acts as a replacement of it.
+
+function parse_svn() {
+ info=$(svn info 2> /dev/null) || return
+ in_svn=true
+ repo_need_upgrade="$(svn_repo_need_upgrade $info)"
+ svn_branch_name="$(svn_get_branch_name $info)"
+ svn_dirty="$(svn_dirty_choose)"
+ svn_repo_name="$(svn_get_repo_name $info)"
+ svn_rev="$(svn_get_revision $info)"
+}
+
+function svn_prompt_info() {
+ eval parse_svn
+
+ if [ ${in_svn} ]; then
+ echo "$ZSH_PROMPT_BASE_COLOR$ZSH_THEME_SVN_PROMPT_PREFIX\
+$ZSH_THEME_REPO_NAME_COLOR${svn_branch_name}\
+$ZSH_PROMPT_BASE_COLOR${svn_dirty}\
+$ZSH_PROMPT_BASE_COLOR$ZSH_THEME_SVN_PROMPT_SUFFIX\
+$ZSH_PROMPT_BASE_COLOR"
+ fi
+}
+
+
+function svn_repo_need_upgrade() {
+ info=$1
+ [ -z "${info}" ] && info=$(svn info 2> /dev/null)
+ [ "${info}" = "E155036" ] && echo "upgrade repo with svn upgrade"
+}
+
+function svn_get_branch_name() {
+ info=$1
+ [ -z "${info}" ] && info=$(svn info 2> /dev/null)
+ echo $info | grep '^URL:' | egrep -o '(tags|branches)/[^/]+|trunk' | egrep -o '[^/]+$' | read SVN_URL
+ echo $SVN_URL
+}
+
+function svn_get_repo_name() {
+ info=$1
+ [ -z "${info}" ] && info=$(svn info 2> /dev/null)
+ echo $info | sed -n 's/Repository\ Root:\ .*\///p' | read SVN_ROOT
+ echo $info | sed -n "s/URL:\ .*$SVN_ROOT\///p"
+}
+
+function svn_get_revision() {
+ info=$1
+ [ -z "${info}" ] && info=$(svn info 2> /dev/null)
+ echo $info 2> /dev/null | sed -n s/Revision:\ //p
+}
+
+function svn_dirty_choose() {
+ svn status | grep -E '^\s*[ACDIM!?L]' > /dev/null 2>/dev/null && echo $ZSH_THEME_SVN_PROMPT_DIRTY && return
+ echo $ZSH_THEME_SVN_PROMPT_CLEAN
+} \ No newline at end of file